(function (global, $) {
  var Checkr = function (desktop) {
    return new Checkr.init(desktop);
  };

  Checkr.prototype = {
    width(
      site = ".site",
      overlay = ".area.overlay-mobile",
      display = "grid"
    ) {
      if (!this.desktop) {
        gsap.set(site, { clearProps: "display" });
        gsap.set(overlay, { display: display });
        this.print();
      } else {
        gsap.set(overlay, { clearProps: "display" });
        gsap.set(site, { display: display });
      }
    },
    print(self = ".width", width = 1200, bar = ".bar.mobile") {
      if (!this.desktop) {
        var size = document.documentElement.clientWidth,
        more = width - size + "px",
        percent = (100 / width) * size + "%";
        $(self).html(more);
        gsap.set(bar, { width: percent });        
      }
    },
  };

  Checkr.init = function (desktop) {
    var self = this;
    self.desktop = desktop;
    this.width();
  };

  Checkr.init.prototype = Checkr.prototype;

  global.Checkr = Checkr;
})(window, $);
