
Site.tl = gsap.timeline({ repeat : -1 });

Site.inFocus = false;

Site.access = {
  ratio : ".access-ratio",
  best  : "best",
  good  : "good",
  poor  : "poor"
}

Site.scramble = {
  chars : "1234567890%",
  speed : 0.6
}

Site.mobile = {
  active : true
}

Site.tablet = {
  active : false,
  width : 768
}

Site.desktop = {
  active : false,
  width : 1200
}

Site.topbar = {
  lnk : ".link.navigation"
}

Site.scroller = ".item.scroller";

Site.chapter = {
  target : ".wrap.type-chapter"
}

Site.page = {
  artwork : ".area.page-artwork",
  share   : ".util-share",
  url     : ".util-url",
  height  : 560
}

Site.rollers = {
  input  : ".list.roller.input",
  output : ".list.roller.output",
  morph  : "svg#morph"
};

Site.charts = {
  list  : ".block.chart-container",
  pcent : ".block.chart-pcent-title",
  title : ".block.chart-title"
};

Site.pies = {
  list  : ".list.pies.style-spin",
  pcent : ".title.pie-pcent",
  wrap  : ".block.pie-wrap",
  data  : ".block.pie-svg-data",
  title : ".title.pie-title"
};

Site.numbers = ".title.number-value";

Site.mobile.query  = `screen and (max-width: ${Site.tablet.width - 1}px)`;
Site.tablet.query  = `screen and (min-width: ${Site.tablet.width}px) and (max-width: ${Site.desktop.width - 1}px)`;
Site.desktop.query = `screen and (min-width: ${Site.desktop.width}px)`;

enquire.register(Site.mobile.query,{

  match : function() {
    Site.mobile.active  = true;
    Site.tablet.active  = false;
    Site.desktop.active = false;
  }

});

enquire.register(Site.tablet.query,{

  match : function() {
    Site.mobile.active  = false;
    Site.tablet.active  = true;
    Site.desktop.active = false;
  }

});

enquire.register(Site.desktop.query,{

  match : function() {
    Site.mobile.active  = false;
    Site.tablet.active  = false;
    Site.desktop.active = true;
  }

});
